// Author: Ivan Kazmenko (gassa@mail.ru)
module slot;
import board;
import common;
import obj;
import quartet;
import rect;
import tile;

import std.range;

import allegro5.allegro;
import allegro5.allegro_primitives;

class Slot : Rect
{
	int borderW;
	ALLEGRO_COLOR borderColor;
	ALLEGRO_COLOR matchColor;
	Tile matchTile;
	bool hasMatch;

	this (Obj parent_, int relX_, int relY_, int w_, int h_, int radius_,
	    ALLEGRO_COLOR fillColor_, int borderW_, ALLEGRO_COLOR borderColor_,
	    ALLEGRO_COLOR matchColor_, Tile matchTile_)
	{
		super (parent_, relX_, relY_, w_, h_, radius_, fillColor_);
		borderW = borderW_;
		borderColor = borderColor_;
		matchColor = matchColor_;
		matchTile = matchTile_;
		hasMatch = false;
	}

	override bool unclickThis (int posX, int posY)
	{
		if (cursorRoot is null)
		{
			return false;
		}
		if (!child.empty)
		{
			return false;
		}
		cursorRoot.relX = 0;
		cursorRoot.relY = 0;
		child ~= cursorRoot;
		cursorRoot.parent = this;
		if (cursorRoot == matchTile)
		{
			addMatch ();
		}
		cursorRoot = null;
		return true;
	}

	override void drawThisPre ()
	{
		super.drawThisPre ();
		al_draw_rounded_rectangle (borderW * 0.5, borderW * 0.5,
		    w - borderW * 0.5, h - borderW * 0.5,
		    radius, radius, borderColor, borderW);
	}

	override void drawThisPost ()
	{
		if (hasMatch)
		{
			al_draw_filled_rounded_rectangle (0, 0, w, h,
			    radius, radius, matchColor);
		}
	}

	void removeMatch ()
	{
		hasMatch = false;
	}

	void addMatch ()
	{
		hasMatch = true;
	}
}
