// Author: Ivan Kazmenko (gassa@mail.ru)
module tile;
import common;
import obj;
import puzzle;
import rect;
import slot;

import std.algorithm;
import std.array;
import std.string;

import allegro5.allegro;
import allegro5.allegro_font;

class Tile : Rect
{
	Puzzle puzzle;
	int row;
	int col;
	ALLEGRO_BITMAP * image;

	this (Obj parent_, int relX_, int relY_, int w_, int h_, int radius_,
	    ALLEGRO_COLOR fillColor_, Puzzle puzzle_, int row_, int col_,
	    ALLEGRO_BITMAP * image_)
	{
		super (parent_, relX_, relY_, w_, h_, radius_, fillColor_);
		puzzle = puzzle_;
		row = row_;
		col = col_;
		image = image_;
	}

	override bool clickThis (int posX, int posY)
	{
		if (cursorRoot !is null)
		{
			return false;
		}
		puzzle.playPart (row, col);
                cursorRoot = this;
                parent.child = parent.child.filter !(x => x != this).array;
		relX = w / 2;
		relY = h / 2;

		{
			auto temp = cast (Slot) parent;
			if (temp !is null)
			{
				temp.removeMatch ();
			}
		}

		return true;
	}

	override void drawThisPost ()
	{
		al_draw_bitmap (image, 0, 0, 0);
	}
}
